datablock TSShapeConstructor(BlockoParrotDts)
{
	baseShape  = "./BlockoParrot.dts";
	sequence0  = "./BlockoParrot_root.dsq root";

	sequence1  = "./BlockoParrot_walk.dsq run";
	sequence2  = "./BlockoParrot_walk.dsq walk";
	sequence3  = "./BlockoParrot_back.dsq back";
	sequence4  = "./BlockoParrot_side.dsq side";

	sequence5  = "./BlockoParrot_root.dsq crouch";
	sequence6  = "./BlockoParrot_Run.dsq crouchRun";
	sequence7  = "./BlockoParrot_Back.dsq crouchBack";
	sequence8  = "./BlockoParrot_Side.dsq crouchSide";

	sequence9  = "./BlockoParrot_look.dsq look";
	sequence10 = "./BlockoParrot_root.dsq headside";
	sequence11 = "./BlockoParrot_root.dsq headUp";

	sequence12 = "./BlockoParrot_jumpfly.dsq jump";
	sequence13 = "./BlockoParrot_jumpfly.dsq standjump";
	sequence14 = "./BlockoParrot_fall.dsq fall";
	sequence15 = "./BlockoParrot_land.dsq land";

	sequence16 = "./BlockoParrot_root.dsq armAttack";
	sequence17 = "./BlockoParrot_root.dsq armReadyLeft";
	sequence18 = "./BlockoParrot_root.dsq armReadyRight";
	sequence19 = "./BlockoParrot_root.dsq armReadyBoth";
	sequence20 = "./BlockoParrot_fly.dsq spearready";  
	sequence21 = "./BlockoParrot_root.dsq spearThrow";

	sequence22 = "./BlockoParrot_side.dsq talk";  

	sequence23 = "./BlockoParrot_death1.dsq death1"; 
	
	sequence24 = "./BlockoParrot_root.dsq shiftUp";
	sequence25 = "./BlockoParrot_root.dsq shiftDown";
	sequence26 = "./BlockoParrot_root.dsq shiftAway";
	sequence27 = "./BlockoParrot_root.dsq shiftTo";
	sequence28 = "./BlockoParrot_root.dsq shiftLeft";
	sequence29 = "./BlockoParrot_root.dsq shiftRight";
	sequence30 = "./BlockoParrot_root.dsq rotCW";
	sequence31 = "./BlockoParrot_root.dsq rotCCW";

	sequence32 = "./BlockoParrot_root.dsq undo";
	sequence33 = "./BlockoParrot_root.dsq plant";

	sequence34 = "./BlockoParrot_root.dsq sit";

	sequence35 = "./BlockoParrot_root.dsq wrench";

   sequence36 = "./BlockoParrot_root.dsq activate";
   sequence37 = "./BlockoParrot_root.dsq activate2";

   sequence38 = "./BlockoParrot_root.dsq leftrecoil";
};  
datablock AudioProfile(BlockoParrotJumpSound)
{
   fileName = "./jumpBlockoParrot.wav";
   description = AudioClose3d;
   preload = true;
};
datablock fxDTSBrickData (BrickBlockoParrotBot_HoleSpawnData)
{
	brickFile = "Add-ons/Bot_Hole/6xspawn.blb";
	category = "Special";
	subCategory = "Holes";
	uiName = "BlockoParrot Hole";
	iconName = "Add-Ons/Bot_BlockoParrot/icon";

	bricktype = 2;
	cancover = 0;
	orientationfix = 1;
	indestructable = 1;

	isBotHole = 1;
	holeBot = "BlockoParrotHoleBot";
};

// when the BlockoParrot brick is initially planted hide it, as most of the time we don't want it to exist since we're in the water
function BrickBlockoParrotBot_HoleSpawnData::onPlant( %this, %obj )
{
	%obj.setRendering(0);
	%obj.setColliding(0);
	%obj.setRaycasting(0);
}

datablock PlayerData(BlockoParrotHoleBot : PlayerStandardArmor)
{
	shapeFile = "./BlockoParrot.dts";
	uiName = "BlockoParrot";

  renderFirstPerson = false;
//   emap = false;
   
//   className = Armor;
   shapeFile = "./BlockoParrot.dts";
   cameraMaxDist = 8;
   cameraTilt = 0.261;//0.174 * 2.5; //~25 degrees
   cameraVerticalOffset = 2.3;
   computeCRC = false;
  
   cameraDefaultFov = 90.0;
   cameraMinFov = 5.0;
   cameraMaxFov = 120.0;
   
   //debrisShapeName = "~/data/shapes/player/debris_player.dts";
   //debris = horseDebris;

	airControl = 1;

   aiAvoidThis = true;

   minLookAngle = -1.5708;
   maxLookAngle = 1.5708;
   maxFreelookAngle = 2.0;

   mass = 80;
   drag = 0.6; //0.9
   density = 0.1;
   maxDamage = 50;		//270
   maxEnergy =  180;	//150
//   repairRate = 0.33;

   rechargeRate = 0.45;	//0.4

   runForce = 3000 * 90;
   runEnergyDrain = 0;
   minRunEnergy = 0;
   maxForwardSpeed = 7;		//6.5
   maxBackwardSpeed = 5;
   maxSideSpeed = 5;

   maxForwardCrouchSpeed = 12;
   maxBackwardCrouchSpeed = 4;
   maxSideCrouchSpeed = 3;

//   maxForwardProneSpeed = 0;
//   maxBackwardProneSpeed = 0;
//   maxSideProneSpeed = 0;

   maxForwardWalkSpeed = 4;
   maxBackwardWalkSpeed = 4;
   maxSideWalkSpeed = 4;

   maxUnderwaterForwardSpeed = 20;
   maxUnderwaterBackwardSpeed = 20;
   maxUnderwaterSideSpeed = 20;

   jumpForce = 25 * 90; //25 * 120;
   jumpEnergyDrain = 0;
   minJumpEnergy = 0;
   jumpDelay = 0.2;

   minJetEnergy = 0;
	jetEnergyDrain = 0;
	canJet = 0;

   minImpactSpeed = 250;
   speedDamageScale = 3.8;

   boundingBox			= vectorScale("1.4 1.4 1.35", 4);
   crouchBoundingBox	= vectorScale("1.4 1.4 1.35", 4);

//   pickupRadius = 0.75;
 
	rideable = false;
	canRide = false;
	paintable = false;

   useCustomPainEffects = true;
	painSound     = "ParrotPainSound";
	deathSound    = "ParrotDeathSound";
	JumpSound			= BlockoParrotJumpSound;

	runSurfaceAngle = 70;
	jumpSurfaceAngle = 70;
   
	maxStepHeight = 1;

	showEnergyBar = false;
	
	//Hole Attributes
	isHoleBot = 1;

	//Spawning option
	hSpawnTooClose = 0;//Doesn't spawn when player is too close and can see it
	  hSpawnTCRange = 8;//above range, set in brick units
	hSpawnClose = 0;//Only spawn when close to a player, can be used with above function as long as hSCRange is higher than hSpawnTCRange
	  hSpawnCRange = 32;//above range, set in brick units

	hType = Neutral; //Enemy,Friendly, Neutral
	  hNeutralAttackChance = 0;
	//can have unique types, nazis will attack zombies but nazis will not attack other bots labeled nazi
	hName = "BlockoParrot";//cannot contain spaces
	hTickRate = 3000;
	
	//Wander Options
	hWander = 1;//Enables random walking
	  hSmoothWander = 1;//This is in addition to regular wander, makes them walk a bit longer, and a bit smoother
	  hReturnToSpawn = 0;//Returns to spawn when too far
	  hSpawnDist = 48;//Defines the distance bot can travel away from spawnbrick
	  hGridWander = 0;//Locks the bot to a grid, overwrites other settings
	
	//Searching options
	hSearch = 0;//Search for Players
	  hSearchRadius = 64;//in brick units
	  hSight = 1;//Require bot to see player before pursuing
	  hStrafe = 1;//Randomly strafe while following player
	hSearchFOV = 0;//if enabled disables normal hSearch
	  hFOVRadius = 6;//max 10
	  hHearing = 1;//If it hears a player it'll look in the direction of the sound

	  hAlertOtherBots = 1;//Alerts other bots when he sees a player, or gets attacked

	//Attack Options
	hMelee = 0;//Melee
	  hAttackDamage = 15;//Melee Damage
	hShoot = 0;
	  hWep = "gunImage";
	  hShootTimes = 4;//Number of times the bot will shoot between each tick
	  hMaxShootRange = 256;//The range in which the bot will shoot the player
	  hAvoidCloseRange = 1;//
		hTooCloseRange = 7;//in brick units

	//Misc options
	hAvoidObstacles = 1;
	hSuperStacker = 1;//When enabled makes the bots stack a bit better, in other words, jumping on each others heads to get to a player
	hSpazJump = 1;//Makes bot jump when the user their following is higher than them

	hAFKOmeter = 1;//Determines how often the bot will wander or do other idle actions, higher it is the less often he does things

	hIdle = 1;// Enables use of idle actions, actions which are done when the bot is not doing anything else
	  hIdleAnimation = 0;//Plays random animations/emotes, sit, click, love/hate/etc
	  hIdleLookAtOthers = 0;//Randomly looks at other players/bots when not doing anything else
	    hIdleSpam = 0;//Makes them spam click and spam hammer/spraycan
	  hSpasticLook = 0;//Makes them look around their environment a bit more.
	hEmote = 1;
};

function BlockoParrotHoleBot::onAdd(%this,%obj)
{
	armor::onAdd(%this,%obj);
	%obj.hIsBlockoParrot = 1;
	%color[%a++] = "0.088785 0.168224 0.616822 1 ";
	%color[%a++] = "0.214953 0.434579 0.0747664 1";
	%color[%a++] = "0.663551 0 0 1";
	%color[%a++] = "0.663551 0 0 1";
	%color[%a++] = "0.663551 0 0 1";

	%choice = getRandom(1,%a);
	%obj.setNodeColor("ALL",%color[%choice]);
	%obj.chestColor =  %color[%choice];
}

function BlockoParrotHoleBot::onBotLoop(%this,%obj)
{
	//Called every cycle
	//Useful for doing unique behaviors during normal loop
}

function BlockoParrotHoleBot::onBotCollision( %this, %obj, %col, %normal, %speed )
{
	//Called once every second the object is colliding with something
	//echo(%obj.isStampeding SPC %col.isHoleBot SPC %obj.getState() !$= "Dead" SPC %col.getState() !$= "Dead" SPC !%col.isStampeding SPC %col.getDataBlock().getName() $= "BlockoParrotHoleBot");
	if(%obj.isStampeding && %col.isHoleBot && %obj.getState() !$= "Dead" && %col.getState() !$= "Dead" && !%col.isStampeding && %col.getDataBlock().getName() $= "BlockoParrotHoleBot")
	{
		//echo("Spreading stampede");
		%col.emote("AlarmProjectile");
		%col.stopHoleLoop();
		FlyAway(%col);
		scheduleNoQuota(4000+getRandom(-750,750),%col,FlyAway,%col);
		scheduleNoQuota(8000+getRandom(-750,750),%col,FlyAway,%col);
		scheduleNoQuota(12000,%col,hStopStampede,%col);
	}
}

function BlockoParrotHoleBot::onBotFollow(%this,%obj,%targ)
{
	//Called when the target follows a player each tick, or is running away
}

function BlockoParrotHoleBot::onBotDamage(%this,%obj,%source,%pos,%damage,%type)
{
	//Called when the bot is being damaged
	if(!%obj.isStampeding && %obj.getState() !$= "Dead" && !%obj.hMelee)
	{
		%obj.stopHoleLoop();
		%obj.emote("AlarmProjectile");
		FlyAway(%obj);
		scheduleNoQuota(4000+getRandom(-750,750),%obj,FlyAway,%obj);
		scheduleNoQuota(8000+getRandom(-750,750),%obj,FlyAway,%obj);
		scheduleNoQuota(12000,%obj,hStopStampede,%obj);
	}
	// %driver = %obj.getMountedObject(0);
	// if( isObject(%driver) && %obj.getDamagePercent() >= 0.5)
	// {
	// if( !getRandom( 0, 1 ) )
	if( %obj.getDamagePercent() >= 0.5 )
		%obj.scheduleNoQuota( 200, ejectRandomPlayer );
	// }
}

function FlyAway(%obj)
{
	if(%obj.hMelee)
		return;
	
	// %obj.setImageTrigger(2,1);
	%obj.setCrouching(1);
	%obj.setjumping(1);
	%obj.setjump(2);
		%obj.forbidJump = true;
		%obj.addVelocity("0 0 24");
		%obj.playThread(0, "spearready"); //animation
		ServerPlay3D(BlockoParrotJumpSound, %obj.getPosition());
		%obj.lastjump = getsimtime();
	%obj.setjump(3);
		%obj.forbidJump = true;
		%obj.addVelocity("0 0 24");
		%obj.playThread(0, "spearready"); //animation
		ServerPlay3D(BlockoParrotJumpSound, %obj.getPosition());
		%obj.lastjump = getsimtime();

	//%obj.setImageTrigger(2,0);

	%obj.isStampeding = 1;

	%x = hGetRandomFloat(0,10,1);

	%y = hGetRandomFloat(0,10,1);
	
	%z = hGetRandomFloat(0,3,1);

	%vec = %x SPC %y SPC %z;
	// hSetAimVector(%obj,%vec);
	%obj.setAimVector( %vec );

	%obj.setMoveY(1);//hGetRandomFloat(6,10,0));

	%obj.hAvoidObstacle();
	%obj.hDetectWall(1);
	// hAvoidObstacle(%obj);
	// hWanderSearchWall(%obj,1);

	//schedule(3000,%obj,hAvoidObstacle,%obj,1);
	
	//%obj.schedule(7000,startHoleLoop);
}

function hStopStampede(%obj)
{
	%obj.startHoleLoop();
	%obj.isStampeding = 0;
}

function BlockoParrotHoleBot::onTrigger(%this, %obj, %trig, %press) {
	if(%trig == 2 && %press && getsimtime() >= %obj.lastjump+400)
	{
		//flap code goes here. What follows is a recreation of the standard jump on a standard armor MINUS a check to be sure we're touching the ground - flying is possible with this.

		//pretty sure it doesn't play a sound either, because, again, I didn't need it for my purposes.
		%obj.forbidJump = true;
		%obj.addVelocity("0 0 24");
		%obj.playThread(0, "spearready"); //animation
		ServerPlay3D(BlockoParrotJumpSound, %obj.getPosition());
		%obj.lastjump = getsimtime();
	}
	else Parent::onTrigger(%this, %obj, %trig, %press);
}

function allowJump(%obj) {
	if(!isObject(%obj)) 
		return;
	%obj.forbidJump = false;
}
